program Grid
  ! < well.T Grid  n1=100 n2=30 interp=1 > mesh.H
  !			      interp=1	means data push
  !			      interp=2  means bin pull
  use sep
  use bin2
  use binpull2
  use averedge_mod

  implicit none
  integer                               :: n12,k1,nd, inttype, stat, frame, n1, n2
  real,    dimension (:,:), pointer     :: triple, xy
  real,    dimension (:),   pointer     :: zz
  real,    dimension (:),   allocatable :: mesh
  real	                                :: d1, d2, o1, o2, x1, x2
  real                                  :: big, small, baseplate

  call sep_init ()
  call from_history (nd, k1) ; if (k1 /= 3) call erexit ("n2 /= 3") 

  call from_par ("n1", n1, 100)
  call from_par ("n2", n2,  30)
  n12 = n1 * n2

  allocate (triple (nd, 3), mesh  (n12))

  call from_either ("xmin", o1) ; call from_either ("xmax", x1)
  call from_either ("ymin", o2) ; call from_either ("ymax", x2)

  d1 = (x1-o1)/(n1-1)
  d2 = (x2-o2)/(n2-1)

  call to_history ("o1", o1) ; call to_history ("d1", d1)
  call to_history ("o2", o2) ; call to_history ("d2", d2)

  call to_history ("label1", "X axis")
  call to_history ("label2", "Y axis")

  call sep_read (triple)

  xy => triple (:,1:2)
  zz => triple (:,3)

  call from_par ("baseplate", baseplate, 0.)
  if (baseplate == 0.) then
     big   = maxval (zz)
     small = minval (zz)    
     baseplate = small - (big-small)/3.
     call to_history ("Computing  baseplate", baseplate)
  end if
  zz = zz - baseplate

  call from_par ("interp", inttype, 1) 
  call from_par ("frame", frame, 1) 
  call sep_close ()

  select case (inttype)
  case (1)
     call bin2_init (n1, n2, o1,d1,o2,d2, xy)
     stat = bin2_lop (.true., .false., mesh, zz)
     if (frame > 0) call averedge (n1, n2, o1, o2, d1, d2, xy, zz, mesh) 
  case (2)
     call binpull2_init (n1, n2, o1,d1,o2,d2, xy)
     stat = binpull2_lop (.true.,.false.,mesh,zz)
     call binpull2_close ()
  case default
     call erexit (" interp=?[12]")
  end select

  call sep_write (mesh)
  deallocate (triple, mesh)
  call exit (0)
end program Grid

