module averedge_mod

  implicit none
  real, dimension (:), allocatable, private :: weight

contains

  subroutine averedge (m1, m2, o1, o2, d1, d2, xy, zz, mm)
    integer                  :: m1, m2
    real                     :: o1, o2, d1, d2
    real, dimension (:)      :: zz
    real, dimension (:,:)    :: xy
    real, dimension (m1, m2) :: mm

    integer                  :: i1, i2

    allocate (weight (size (zz)))
    do i1 = 1, m1 
       mm (i1,  1) = averpoit (i1,  1, o1, o2, d1, d2, xy, zz)
       mm (i1, m2) = averpoit (i1, m2, o1, o2, d1, d2, xy, zz)
    end do
    do i2 = 1, m2
       mm ( 1, i2) = averpoit ( 1, i2, o1, o2, d1, d2, xy, zz)
       mm (m1, i2) = averpoit (m1, i2, o1, o2, d1, d2, xy, zz) 
    end do
    deallocate (weight)

  contains

    function averpoit (i1, i2, o1, o2, d1, d2, xy, zz) result (mm) 
      real                    :: mm, o1, o2, d1, d2
      integer                 :: i1, i2
      real,   dimension (:)   :: zz
      real,   dimension (:,:) :: xy

      real                    :: x1, x2

      x1 = o1 + (i1 - 1) * d1
      x2 = o2 + (i2 - 1) * d2
      weight = 1./((x1 - xy(:,1))**2 &
      +            (x2 - xy(:,2))**2 )**2  ! distance to 4th power
      mm = sum (zz*weight) / sum (weight)
    end function averpoit

  end subroutine averedge

end module averedge_mod
