# Conv  - filter on 1-axis with options for end-effects, cubes, conjugate 
#
#	<in.H	Conv filtin=fin.H [edge=2 cube=3 conj=0]  >out.H
#  input- 
#	in.H	data cube
#	filtin  data cube of filters.
#	edge	=1	(cvi1) filter does not go off either end of input
#	edge	=2	(contrunc) output is as long as input
#						(lag=1	is sought on filtin)
#	edge	=3	(contran) output is longer than input
#	cube	=3 	one filter for whole cube of inputs.
#	cube	=2 	one filter for each plane of inputs.
#	cube	=1 	one filter for each trace of inputs.
# BUGS:	conjugate behavior like canon library not installed.
# BUGS:	does not check compatibility dimension of in.H and filtin
# /sep/jon/book3/conj/Conv
# keyword filter convolve canon book3
#%
integer n1, nf
from history:	integer n1
call putlin('Convolution')
from aux:	filtin integer n1:nf
allocate:	real xx(n1), yy(n1+nf), ff(nf)

subroutine doit( nf, n1, xx, yy, ff)
integer	esize, nx, nf, ny, i1, n1, i2, n2, i3, n3, cube, edge, lag, conj
real xx(n1), yy(n1+nf), ff(nf)
character*1 filtname(80)
from history:	integer n2=1, n3=1
from history:	integer esize
from par:	integer  edge=1, cube=3, conj=100
if( conj != 100)
	call erexit('sorry, conjugate behavior not yet built')
# conjugate behavior when installed needs to mess with nx,ny
nx = n1
if     ( edge == 1 )
#			ny = n1-nf+1
			ny = n1
else if( edge == 2 )
			call erexit( ' contrunc is banished')
else if( edge == 3 )
			ny = n1+nf-1
else
		call erexit('Conv: bad edge')
call putch( 'n1','i', ny)
if( edge == 2) {
 	from aux:	filtin integer lag=1
	}
if( esize != 4) call erexit('bad esize')
call hclose()					#close header, no more putch
if( cube == 3 )
	call sreed('filtin', ff, 4*nf)
do i3= 1, n3 {
	if( cube == 2 )
		call sreed('filtin', ff, 4*nf)
	do i2= 1, n2 {
		if( cube == 1 )
			call sreed('filtin', ff, 4*nf)
		call sreed( 'in',  xx, 4*nx)
		if( edge == 1)
#			call convin(0, 0,  nx,xx, nf, ff, yy)
#			call cvi1(  0, 0, 1, ff,nf,  xx,nx, yy)
			call icai1( 0, 0, 1, ff,nf,  xx,nx, yy)
#		if( edge == 2)
#			call contrunc(0, 0,lag, nx,xx,nf,ff,ny,yy )
		if( edge == 3)
			call tcai1(0, 0,xx,nx, ff,nf,yy )
#			call contran(0, 0,nx,xx,nf,ff,yy )
		call srite( 'out', yy, 4*ny)
		}
	}
return; end
