program Conv
  use sep
  use tcai1
  use icai1
  implicit none

  integer                       :: stat, nx , nf , ny , i2 , n2 , i3 , n3
  integer                       :: cube, edge , lag , conj
  real, dimension (:), pointer 	:: xx, yy, ff

  call sep_init()
  call from_history (nx,n2,n3)

  call putlin("Convolution")
  call from_aux ("filtin","n1",nf)

  allocate (xx (nx))
  allocate (ff (nf))

  call from_par ("edge",edge,1)
  call from_par ("cube",cube,3)
  call from_par ("conj",conj,100)
  call from_par ("lag",lag,1)

  if( conj .ne. 100) call erexit('sorry, conjugate behavior not yet built')

  select case (edge)
  case (1)
     ny = nx
  case (2)
     call erexit( ' contrunc is banished')
  case (3)
     ny = nx+nf-1
  case default
     call erexit('Conv: bad edge')
  end select

  allocate (yy (ny))
  call to_history ("n1",ny)
  call sep_close()

  if (cube == 3) call sep_read (ff, "filtin")

  do i3= 1, n3 
     if( cube == 2 ) call sep_read (ff, "filtin")
     do i2= 1, n2 
        if (cube == 1) call sep_read (ff, "filtin")
        call sep_read (xx)
        if (edge == 1) then
           call icai1_init (ff,1)
           stat = icai1_lop ( .false., .false., xx, yy)
        endif
        if (edge == 3) then
           call tcai1_init (ff)
           stat = tcai1_lop ( .false., .false., xx, yy)
        endif
        call sep_write (yy)
     end do
  end do

  deallocate (xx,ff,yy)
  call exit (0)
end program Conv





