program Light
  use hipass
  use sep

  implicit none
  integer                            :: n1, n2, stat, i1, i2
  real                               :: ax, ay, eps
  real, dimension (:,:), allocatable :: map, dx, dy

  call sep_init ()
  call from_history (n1, n2)
  call from_par ("ax",ax,1.)
  call from_par ("ay",ay,1.)
  call from_par ("eps",eps,0.)
  call sep_close ()

  allocate (map (n1, n2), dx (n1, n2), dy (n1,n2))
  call sep_read (map)
  if (eps > 0.) then
     call hipass_init (eps)
     do i2=1,n2
        stat = hipass_lop (.false., .false., map (:,i2), dx (:,i2))
     end do
     do i1=1,n1
        stat = hipass_lop (.false., .false., map (i1,:), dy (i1,:))
     end do
  else
     !     dx = map (3:,:) - map (:n1-1,:); dy = map (:,3:) - map (:,:n2-1)
     dx(2:n1,:) = map (3:n1,:) - map (1:n1-2,:) 
     dy(:,2:n2) = map (:,3:n2) - map (:,1:n2-2)
  end if
  dx (1,:) = 0.; dy (:,1) = 0.; dx (n1,:) = 0.; dy (:,n2) = 0.
  if (ax == 0. .and. ay==0.) then
     ax = 1.; ay = - sum(dx*dy)/sum(dy*dy)
     write (0,*) "ay = ", ay
  end if
  call sep_write (ax*dx+ay*dy)
  deallocate (map,dx,dy)
  call exit (0)
end program Light
