program Runmed
  !  <in.H Runmed.x nmed=5 > out.H
  !     
  use quantile_mod
  use sep

  implicit none
  integer                                     :: nc, nd, id, nmed, nh, md, i, tracklen, ruftr
  real                                        :: thresh
  real, dimension (:,:), allocatable, target  :: xyz
  real, dimension (:,:),              pointer :: xy
  real, dimension (:),   allocatable          :: ww, rr, ss
  real, dimension (:),                pointer :: zz

  call sep_init ()
  call from_history (nd, nc); if ( nc /= 3 .and. nc /= 4) call erexit( 'nc is not 3 or 4')
  call to_history ("n2", 4)
  call from_par ("nmed", nmed, 5)
  call from_par ("ruftr", ruftr, 0)

  allocate (xyz (nd, nc), rr (nd), ww (nd), ss (nd))
  call sep_read (xyz)
  xy => xyz (:,:2)
  zz => xyz (:,3)

  rr(1) = 0.
  rr(2:) =                      &
  (xy(2:,1)-xy(:nd-1,1))**2 + &
  (xy(2:,2)-xy(:nd-1,2))**2

  thresh = quantile (nd/2, rr) * 16. ! Set thresh = 4 times the median jump.
  call to_history ("thresh", sqrt(thresh))
  call sep_close ()

  ww = 1.
  id = 1
  do while (id<=nd) 				! loop over tracks
     do i=id,nd-1
        if (rr(i)  > thresh) exit
     end do
     md = i-id+1
     if ( md >= nmed ) then
        nh = nmed/2
        ss (:md) = zz (id:id+md-1)
        do i= id, id+md-nmed 			! running median 
           ss (i+nh-id+1) = quantile (1+nh, zz (i:i+nmed-1))
        end do
        ww(id      :id+nh-1) = 0.
        ww(id+md-nh:id+md-1) = 0.
        zz (id:id+md-1) = ss (:md)		
     else					! throw away short track.
        ww (id:id+md-1) = 0.
     end if
     id=id+md
  end do

  call sep_write (xyz)
  call sep_write (ww)

  deallocate (xyz, ww, rr, ss)
  call exit (0)
end program Runmed



